#!/usr/bin/perl
#!/usr/bin/perl -w
# Legal Stuff:
# RAM-CMS - Really Amazing Modest Content Management System.
# Copyright (C) 2007,2008 Robert Alex Marder.
# E-Mail: ralexwebs@inbox.com
# WWW: http://www.nongnu.org/ram-cms/
# Version: 0.3.0rc1
# This is the official Perl port of RAM-CMS.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
# or see <http://www.gnu.org/licenses/>.

use strict;
use CGI qw(param);
use vars qw($compress $conceal $pages_dir $def_page $ext $ext_plugin $nicelinks $nocache $bbcode $strip_whitespace $site_name $copyright $theme_file);
use vars qw($page $page_template $ext $updated_show $title $header $body $is_plugin);

if(!defined(param('page')))
{
	$page='';
}
else
{
	$page=param('page');
}

require 'config.pl';
require 'functions.pl';

# include the $theme_file so we have a template to work with.
# if $theme_file isn't defined in config.pl, or if the $theme_file 
# doesn't exist, then return HTTP 500 Error.
if(defined($theme_file) && $theme_file ne '')
{
	$page_template=file_get_contents('themes/'.$theme_file);
}
else
{
	$nocache=1;
	print "Status: 500\r\n";
	ramcms_send_http_headers($nocache);
	print "Fatal Error: Unable To Find / Open / Read Theme File.";
	exit;
}

### START MAIN PROGRAM ###

# if $page ends with a / character then append $def_page to it and set it to $page
# this allows home pages to work in subdirectories off of pages/ directory.
if(defined($page) and substr($page,-1) eq '/')
{
	$page=$page.$def_page;
}

# if $page is not set or empty string, we should assume the $def_page is what 
# we want to show.
if(!defined($page) or $page eq '')
{
	$page=$def_page;
}

# TODO: Port this to Perl
# quick compression (gzip, deflate, none) if supported by PHP and client.
#if($compress==true && function_exists('ob_gzhandler')==true && function_exists('ob_start')==true)
#{
#	ob_start('ob_gzhandler');
#}

# determine whether we should return 404 page.
# if $page include .. or if $page starts with a / then we will return 404 as a security measure.
#if(file_exists($pages_dir.$page.$ext)==false || strstr($page,'..')!=false || substr($page,0,1)=='/')
if(index($page,'..')!=-1 || substr($page,0,1) eq '/')
{
	$page='404';
}
if(!((-e $pages_dir.$page.$ext) || (-e $pages_dir.$page.$ext_plugin)))
{
	$page='404';
}

# if the page wasn't found return HTTP 404 Not Found and don't cache.
if($page eq '404')
{
	print "Status: 404\r\n";
	$nocache=1;
	$is_plugin=0;
}

# determine if $page is a plugin
if((!(-e $pages_dir.$page.$ext)) && (-e $pages_dir.$page.$ext_plugin))
{
	$is_plugin=1;
	$nocache=1;
}
else
{
	$is_plugin=0;
}

### TODO
# determine if the client will be happy with a 304 Not Modified response.
### TODO

if($is_plugin==0)
{
	# page requested is not a program, but a standard static page.
	# format it as required.
	
	# determine last time page was updated.
	$updated_show=ramcms_last_update_time($pages_dir.$page.$ext,0);
	
	open(FH,$pages_dir.$page.$ext) || exit("Error: unable to open page: ".$page);
	my @raw_datain=<FH>;
	close(FH);
	# grab the title, always the first line.
	$title=shift(@raw_datain);
	# grab the header, always second line.
	$header=shift(@raw_datain);
	
	# grab body, line three till EOF
	my $line='';
	$body='';
	foreach $line (@raw_datain)
	{
		$body=$body.$line;
	}

}
else
{
	# page requested is a program, deal with it accordingly.
	$updated_show='unknown';
	
	require $pages_dir.$page.$ext_plugin;
}

# send HTTP headers
ramcms_send_http_headers($nocache,$page,$conceal);

# start parsing the template and filling in as needed.
if($bbcode==1)
{
	ramcms_bbcode_parser(\$body,$nicelinks);
}

if($strip_whitespace==1)
{
	ramcms_remove_body_whitespace(\$body);
}

ramcms_page_template_parser(\$page_template,$title,$site_name,$header,$updated_show,$body,$copyright,$conceal);

if($strip_whitespace==1)
{
	ramcms_remove_body_whitespace(\$page_template);
}

# dump the entire page to the server, for sending to client.
print $page_template;

